import argparse 

def readParameters():
	parser = argparse.ArgumentParser()
	parser.add_argument("-b", "--barcode", type=str, help="The file containing the barcodes.")
	parser.add_argument("-f", "--firstfile", type=str, help="The first input fastq file.")
	parser.add_argument("-r", "--secondfile", type = str, help="The second input fastq file.")
	parser.add_argument("-o", "--output", type = str, help="The output folder.")
	return parser.parse_args()

def hamming_distance(string1, string2): 
    # Start with a distance of zero, and count up
    distance = 0
    # Loop over the indices of the string
    L = len(string1)
    for i in range(L):
        # Add 1 to the distance if these two characters are not equal
        if string1[i] != string2[i]:
            distance += 1
    # Return the final count of differences
    return distance

new_file_prefix = "Ex_"
parameters = readParameters()
# read the barcode file
# parameters = lambda: None
# parameters.barcode = "/mnt/extra/PracticalCourse2019/data/demulti_res/10cells_barcodes.txt"
with open(parameters.barcode, "r") as f:
	barcodes = [line.strip('"\n') for line in f]

# read the first file
# parameters.firstfile = "/mnt/extra/PracticalCourse2019/data/demulti_res/10cells_read1.fastq"
with open(parameters.firstfile, "r") as f:
	content1 = [line.strip('"\n') for line in f]

# read the second file
# parameters.secondfile = "/mnt/extra/PracticalCourse2019/data/demulti_res/10cells_read2.fastq"
with open(parameters.secondfile, "r") as f:
	content2 = [line.strip('"\n') for line in f]

# loop through all values
all_in = []
output = [[],[],[],[],[],[],[],[],[],[]] 
for i in range(0, len(content2), 4):
	id1 = content1[i]
	sequence = content1[i+1]
	barcode = sequence[:12]
	umi = sequence[12:]
	distances = [hamming_distance(barcode, i)  for i in barcodes]
	index = distances.index(min(distances))
	if(min(distances) < 2):
		id_ = content1[i] + ":" + umi
		output[index].append(id_ + "\n" + content2[i+1] + "\n" + content2[i+2] + "\n" + content2[i+3])

# write the output
# parameters.output = "/mnt/extra/PracticalCourse2019/data/demulti_res/new/"
for index, i in enumerate(barcodes):
	filename = parameters.output + new_file_prefix + i + ".fq"
	file = open(filename, "w")
	for j in output[index]:
		file.write(j + "\n")
