### Always make sure to supply full-path names for the software tools.
### e.g. /home/$USER/Downloads/bin/FastQC/fastqc instead of just fastqc

# Exercise 1
unzip data1.zip
cd data1/
mkdir fastqc_results
fastqc -o fastqc_results/ ERR522959_1.fastq.gz ERR522959_2.fastq.gz

mkdir trimmed_results
trim_galore --nextera -o trimmed_results/  ERR522959_1.fastq.gz ERR522959_2.fastq.gz
# Examine again the trimmed results
fastqc -o trimmed_results/ trimmed_results/ERR522959_1_trimmed.fq.gz trimmed_results/ERR522959_2_trimmed.fq.gz


# Exercise 2
unzip data2.zip
cd data2
mkdir genome_index
mkdir alignment
STAR --runThreadN 4 --runMode genomeGenerate --genomeDir genome_index/ --genomeFastaFiles smaller_reference.fa
STAR --runThreadN 4 --genomeDir genome_index/ --readFilesIn reads_subset_1.fastq reads_subset_2.fastq --outFileNamePrefix alignment/
samtools view -hbS alignment/Aligned.out.sam > alignment/output.bam
samtools sort alignment/output.bam > alignment/output.sorted.bam
samtools index alignment/output.sorted.bam


# Exercise 3
unzip data3.zip
cd data3
mkdir results
python3 ../scripts/demultiplexing.py -b 10cells_barcodes.txt -f 10cells_read1.fastq -r 10cells_read2.fastq -o results/


# Exercise 4 seuratObject.R
